/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2007 EBM Websourcing, http://www.ebmwebsourcing.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id$
 * -------------------------------------------------------------------------
 */

package org.ow2.petals.transport.platform.memory;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.BlockingQueue;

import javax.jbi.messaging.MessageExchange;

import org.ow2.petals.transport.ProtocolMonitor;
import org.ow2.petals.transport.TransportException;

/**
 *
 * @author ofabre - eBM Websourcing
 *
 */
public class MemoryMonitoring implements ProtocolMonitor {

    private MemoryTransporter transporter;

    public MemoryMonitoring(MemoryTransporter transporter) {
        super();
        this.transporter = transporter;
    }

    public int getQueueMaxSize() throws TransportException {
        return transporter.getQueueSize();
    }

    public Map<String, Integer> getQueueSizes() throws TransportException {
        Map<String, Integer> result = new HashMap<String, Integer>();
        Map<String, BlockingQueue<MessageExchange>> componentQueues = transporter
                .getComponentQueues();
        for (String componentName : componentQueues.keySet()) {
            result.put(componentName, componentQueues.get(componentName).size());
        }
        return result;
    }

}
